/*
-------------------------------------------------------------
RSA e Crittografia Simmetrica fTm (for the Mass) - 05/03/2000
-------------------------------------------------------------
Date: 05/03/2000
Written by: valv{0} - valvoline@tiscalinet.it
          : vecna   - vecna@itapac.net
consumo   : almeno 2 fegati propri. (vecna)
          : ...e ki se lo rikorda! (valv0)
dedicato a: tendenzialmente a mAyhEm. (vecna)
            La mia Lady, il mio prof. di Crittografia (valv0)
X-warning : Io non sono responsabile se la mia libreria e` ciccata, ho
            fatto molti test e gli ho dedicato abbastanza tempo per
            farla, fatto sta`, che sono ancora umano e come tale posso
            ancora sbagliare. (vecna)

  ------------------------------------------------------------
  DISCLAIMER: Questo progetto, e' stato sviluppato a scopo
  esclusivo di ricerca e sviluppo, per la rivista B.F.I.
  Qualunque utilizzo dello stesso, per scopi diversi da
  quelli di ricerca, sviluppo sono vietati.
  ------------------------------------------------------------
  !WARNING!
  Questo prodotto, contiene algoritmi di crittografia,
  classificata STRONG. E' soggetto, pertanto, alle limitazioni
  di esportazione e/o importazione vigenti negli Stati Uniti.
  ------------------------------------------------------------

-------------------------------------
Inizio Prototipo Programma Principale
-------------------------------------
Quello che segue e' un semplice scheletro di programma da potere
utilizzare con le librerie fornite a corredo.
In un secondo tempo, saranno eliminate queste dichiarazioni di
procedure e funzioni dal main (colpa mia, che non ho mai tempo!).
Le librerie da includere sono specificate sotto.
E' possibile utilizzare contemporaneamente tutti e due i prodotti
forniti a corredo (RSA & anekkev). Nelle prossime implementazioni
le due implementazioni saranno fuse insieme in maniera sinergica.
--------------------------------------[[valv{0}]]
*/

#include "stdio.h"
#include "stdlib.h"
#include "rsa.hpp"
#include "prime.hpp"
#include "anekkev.h"


// Estrazione da stringhe - Puo' essere ottimizzata
// In seguito forse....:)
static vlong from_str( const char * s )
{
  vlong x = 0;
  while (*s)
  {
    x = x * 256 + (unsigned char)*s;
    s += 1;
  }
  return x;
}

void private_key::create( const char * r1, const char * r2 )
{
  // Scelta numeri primi
  {
    prime_factory pf;
    p = pf.find_prime( from_str(r1) );
    q = pf.find_prime( from_str(r2) );
    if ( p > q ) { vlong tmp = p; p = q; q = tmp; }
  }
  // Calcolo della chiave pubblica
  {
    m = p*q;
    e = 5001; // Deve essere un numero dispari 
			   // (p-1) e (q-1) sono pari
    // Calcolo di e
	while ( gcd(p-1,e) != 1 || gcd(q-1,e) != 1 ) e += 2;
	
  }
}

vlong public_key::encrypt( const vlong& plain )
{
  return modexp( plain, e, m );
}

vlong private_key::decrypt( const vlong& cipher )
{

  // Calcolo valori per effettuare il decrypt
  // Questi valori potrebbero essere messi in cache, in una successiva ottimizzazione del codice.
  vlong d = modinv( e, (p-1)*(q-1) );
  vlong u = modinv( p, q );
  vlong dp = d % (p-1);
  vlong dq = d % (q-1);

  // Applichiamo, adesso, il teorema del resto cinese.
  vlong a = modexp( cipher % p, dp, p );
  vlong b = modexp( cipher % q, dq, q );
  if ( b < a ) b += q;
  return a + p * ( ((b-a)*u) % q );
}


// INIZIO PROTOTIPO PROGRAMMA PRINCIPALE
// -------------------------------------
void main() {
	char *c1="iogtokgrkgokrtg";
	char *c2="rtjgoweldsal";
	vlong result, d, m,temp;
	unsigned int i;
	public_key pub;
	private_key pri;

	printf("\nCrypto Library for BFI #8 (http://www.s0ftpj.org) - v1.0b\n");
	printf("Freeware 2000/2005 - valv{0} & vecna\n");
	// Usiamo RSA
	printf("\nUsing RSA Library...\n");

	pri.create(c1, c2);
	printf("p: %u\n", pri.p.bits());
	printf("q: %u\n", pri.q.bits());
	printf("m: %u\n", pri.m.bits());
	printf("e: %u\n", pri.e.bits());

	result = (pri.p -1)* (pri.q -1);
	//d = (pri.e^-1)%result;
	printf("result: %u\n", result.bits());	
	printf("d: %u\n", d.bits());	
	
	// Usiamo anekkev
	printf("\nUsing anekkev Library...\n");
	char *key1="initinitinit";
	char *plain="my_string_1";
	char *key2, *crypted;
	key2 = anekkev::build_key(key1);
	crypted = anekkev::crypt(plain, key2);

*/
}

