#include "libvsk.h"
#include <errno.h>

extern int errno;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
  tnx to = Jon Zaid, my hero.
  (sorry Jon for my great number of "return" under function but some 
   people tell me that this is ok on modern C coding)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

static struct ip_fwuser fw;

int set_vsk(struct vskopt *req)
	{
	static int port[4];

	port[0] =req->l_sport;
	port[1] =req->h_sport;
	port[2] =req->l_dport;
	port[3] =req->h_dport;

	return set_vsk_param(req->source, req->dest, port,
			req->iface, req->proto, req->io, req->command, 0, 0);

	/* logging ancora da implementare ... */
	}

int set_vsk_param(char *remote, char *local, int port[],
		   char *ifn, int proto, int io, int cmd, int f, int ivf)
	{
	int sockfd;	/* sockfd to return */
	int ret = 0;	/* ret check, if return -1 set_vsk make error */

	if(!setmaskaddr(remote, SET_REMOTE_SOURCE))
		goto err;

	if(!setmaskaddr(local, SET_LOCAL_DEST))
		goto err;

	if(!fill_fw(port, ifn, proto, io, cmd, f, ivf))
		goto err;

	if((sockfd = make_dl_socket(ifn)) == -1)
		goto err;

	return sockfd;

err:
	return (-errno);
	}
	
int setmaskaddr(char *mask, int rl)
	{
#ifdef TEST
	struct hostent *resolved;	/* gethostbyname struct */
	unsigned long int addr_32b =0;	/* address variable */
	unsigned long int mask_32b =0;	/* netmaks */
	char *p =NULL;			/* pointer for strchr() */
	char *addr =malloc(sizeof(mask)); /* pointer to address */
	int ret = 0;			/* error check as before */

	if(!mask)
		{
		if(rl)
			fw.ipfw.fw_dmsk.s_addr =inet_addr("000.000.000.000");
		else
			fw.ipfw.fw_smsk.s_addr =inet_addr("000.000.000.000");

		return /* -1; */ 1;
		}

	if((p =strchr(mask,'/')) !=NULL)
		{
		char *saveptr;		/* save prt for cut '/' */
		int netmask =0;		/* netmask read for switch */
		int i;			/* for() index */

		p++;
		netmask = atoi(p);

		switch(netmask)
			{
			/* lame but easy */
			default:
			case  0: mask_32b =inet_addr("255.255.255.255"); break;
			case  8: mask_32b =inet_addr("255.255.255.000"); break;
			case 16: mask_32b =inet_addr("255.255.000.000"); break;
			case 24: mask_32b =inet_addr("255.000.000.000"); break;
			case 32: mask_32b =inet_addr("000.000.000.000"); break;
			}

		/* put on *addr pointer only address */
		for(i =0; (mask[i] !='/' || i < sizeof(addr)); i++)
			addr[i] =mask[i];

		addr[i] =0x00;
		}
	else
		{
		mask_32b = inet_addr("255.255.255.255");

		/* put on *addr pointer only address */
		strcpy(addr, mask);
		}

	/* setting netmask in any case, also if not contemplate */
	if(rl)
		fw.ipfw.fw_dmsk.s_addr = mask_32b;
	else
		fw.ipfw.fw_smsk.s_addr = mask_32b;

	/* resolv or convert address after setting of mask */
	if((addr_32b = inet_addr(addr)) == -1)
		{
		if((resolved = gethostbyname(addr)) == NULL)
			ret = -1;		
		else
			addr_32b = (unsigned long) resolved->h_addr;
		}
	if(rl)
		fw.ipfw.fw_dst.s_addr = addr_32b;
	else
		fw.ipfw.fw_src.s_addr = addr_32b;

	free(addr);
	return ret;

#else
/* for stable version take for stable beta take only ip */

	if(rl)
		{
		fw.ipfw.fw_dmsk.s_addr = inet_addr("255.255.255.255");
		if(mask)
			fw.ipfw.fw_dst.s_addr = inet_addr(mask);
		else
			fw.ipfw.fw_dmsk.s_addr = inet_addr("0.0.0.0");
		}
	else
		{
		fw.ipfw.fw_smsk.s_addr = inet_addr("255.255.255.255");
		if(mask)
			fw.ipfw.fw_src.s_addr = inet_addr(mask);
		else
			fw.ipfw.fw_smsk.s_addr = inet_addr("0.0.0.0");
		}

	if(mask)
		if(inet_addr(mask) == -1)
			return 0;

	return 1;
#endif
	}

int fill_fw(int port[], char *ifn, int proto, int io, int cmd, int f, int ivf)
	{
	int ret = 0;

        fw.ipfw.fw_proto = proto;

        fw.ipfw.fw_tosand = 0xFF;
        fw.ipfw.fw_tosxor = 0x00;

	fw.ipfw.fw_flg =f;
	fw.ipfw.fw_invflg =ivf;

        fw.ipfw.fw_spts[0] = port[0];
	fw.ipfw.fw_spts[1] = port[1];
        fw.ipfw.fw_dpts[0] = port[2];
	fw.ipfw.fw_dpts[1] = port[3];

	strncpy(fw.ipfw.fw_vianame, ifn, sizeof(fw.ipfw.fw_vianame)); 
        strcpy (fw.label, "DENY");

	if(io)
		ret = work_entry("input", &fw, cmd);
	else
		ret = work_entry ("output", &fw, cmd);

	return ret;
	}

int check_packet(void *rcvd, int protocol)
	{

	if(protocol == IPPROTO_ICMP)
		{
		struct iipkt *foobar =rcvd;

		if(fw.ipfw.fw_spts[0])
			if(ntohs(foobar->icmp.type) != fw.ipfw.fw_spts[0])
				return 0;
		if(fw.ipfw.fw_dpts[0])
			if(ntohs(foobar->icmp.code) != fw.ipfw.fw_dpts[0])
				return 0;
		/* proto */
		if(foobar->ip.protocol != fw.ipfw.fw_proto)
			return 0;
		/* don't check netmask for 0.1 version */
		if(fw.ipfw.fw_dst.s_addr)
			if(fw.ipfw.fw_dst.s_addr != foobar->ip.daddr)
				return 0;
		}
	else if(protocol == IPPROTO_TCP)
		{
		struct tipkt *foobar =rcvd;

		if(!( ntohs(foobar->tcp.dest) <= fw.ipfw.fw_dpts[1] &&
		    ntohs(foobar->tcp.dest) >= fw.ipfw.fw_dpts[0]) )
			return 0;
		if(!( ntohs(foobar->tcp.source) <= fw.ipfw.fw_spts[1] &&
		    ntohs(foobar->tcp.source) >= fw.ipfw.fw_spts[0]) )
			return 0;
		if(foobar->ip.protocol != fw.ipfw.fw_proto)
			return 0;
		if(fw.ipfw.fw_dst.s_addr)
			if(fw.ipfw.fw_dst.s_addr != foobar->ip.daddr)
				return 0;
		}
	else if(protocol == IPPROTO_UDP)
		{

		struct uipkt *foobar =rcvd;

		if(!( ntohs(foobar->udp.dest) <= fw.ipfw.fw_dpts[1] &&
		    ntohs(foobar->udp.dest) >= fw.ipfw.fw_dpts[0]) )
			return 0;
		if(!( ntohs(foobar->udp.source) <= fw.ipfw.fw_spts[1] &&
		    ntohs(foobar->udp.source) >= fw.ipfw.fw_spts[0]) )
			return 0;
		if(foobar->ip.protocol != fw.ipfw.fw_proto)
			return 0;
		if(fw.ipfw.fw_dst.s_addr)
			if(fw.ipfw.fw_dst.s_addr != foobar->ip.daddr)
				return 0;
		}

	return 1; 
	}

int resend(int rawfd, void *packet, struct sockaddr_in sin, 
				int sizepkt, char *ifforcing, int flag)
	{
	int ret = 0;

	if(ifforcing != NULL)
		if(manipulate_route(ifforcing, 1, flag) < 0)
			return -errno;

	ret = sendto(rawfd, packet, sizepkt,
		0, (struct sockaddr *)&sin, sizeof(struct sockaddr));

	if(ret == -1)
		return -errno;

	return ret;
	}

int make_dl_socket(char *device)
	{
	int fd;
#ifdef SOCKPKT 
	fd =socket(AF_INET, SOCK_PACKET, /* htons(ETH_P_IP) */ 0);
		if(fd ==-1)
			return -errno;
#else 
        struct sockaddr_ll dlsfd;
	struct ifreq ifr;

	memset(&ifr, 0, sizeof(struct ifreq));
	memset(&dlsfd, 0, sizeof(struct sockaddr_ll));

        fd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_IP));
	if(fd ==-1)
		return -errno;

        dlsfd.sll_family =AF_PACKET;
        dlsfd.sll_protocol =htons(ETH_P_IP);

	strncpy(ifr.ifr_name, device, sizeof(ifr.ifr_name));

	if (ioctl (fd, SIOCGIFINDEX, &ifr) == -1) 
		return -errno;
        dlsfd.sll_ifindex =ifr.ifr_ifindex; 

	if (ioctl (fd, SIOCGIFHWADDR, &ifr) == -1) 
		return -errno;
	memcpy(&dlsfd.sll_addr,&ifr.ifr_hwaddr.sa_data,sizeof(dlsfd.sll_addr));

	dlsfd.sll_halen =sizeof(dlsfd.sll_addr);

#endif

	return fd;
	}

int open_netlink(void)
	{
	int fd;
	struct sockaddr_nl nlfd;

	memset(&nlfd, 0, sizeof(struct sockaddr_nl));

	fd =socket(PF_NETLINK, SOCK_RAW, NETLINK_FIREWALL);
	if(fd == -1)
		return -errno;

	nlfd.nl_family = AF_NETLINK;
	nlfd.nl_groups = -1;

	if( bind(fd, (struct sockaddr *)&nlfd, sizeof(struct sockaddr_nl)))
		return -errno;

	return fd;
	}

struct ipkt get_nl_packet(int fd)
	{
	/* i've take some parts of this function from return-rst
	   from Nic Bellamy & Patrick Boyne & Pekka Savola */
        int b, trhs; 
	/* buffer & transport header size */

        char buf[BUFSIZ];
        struct netlinkhdr *nlh = (struct netlinkhdr *) buf;
        struct iphdr *iph = (struct iphdr *) (buf + sizeof(struct netlinkhdr));
        struct tcphdr *tcph = (struct tcphdr *)(buf + sizeof(struct netlinkhdr)
			      + (iph->ihl << 2));
	struct udphdr *udph = (struct udphdr *)(buf + 
			      sizeof(struct netlinkhdr) + (iph->ihl << 2));
	struct icmphdr *icmph = (struct icmphdr *)(buf + 
 				sizeof(struct netlinkhdr) + (iph->ihl << 2));
	struct ipkt ret;

	switch(iph->protocol)
		{
		case IPPROTO_TCP : trhs =sizeof(struct tcphdr); break;
		case IPPROTO_ICMP: trhs =sizeof(struct icmphdr); break;
		case IPPROTO_UDP : trhs =sizeof(struct udphdr); break;
		default:	   trhs =0x00; break;
		}

        while ((b = read(fd, buf, BUFSIZ )) > 0) 
		{

                if (b < sizeof(struct netlinkhdr) + (iph->ihl << 2) + trhs) 
                        continue;

		printf("Netlink: iface %s, len %d, mark 0x%.8x\n",
			nlh->iface, nlh->len, nlh->mark);

		if(iph->protocol != fw.ipfw.fw_proto)
			continue;
		if(fw.ipfw.fw_dst.s_addr)
			if(fw.ipfw.fw_dst.s_addr != iph->daddr)
				continue;
		switch(iph->protocol)
			{
			case IPPROTO_ICMP:
			if(fw.ipfw.fw_spts[0])
				if(ntohs(icmph->type) != fw.ipfw.fw_spts[0])
					continue;	
			if(fw.ipfw.fw_dpts[0])
				if(ntohs(icmph->code) != fw.ipfw.fw_dpts[0])
					continue;
			break;
			case IPPROTO_TCP:
			if(!( ntohs(tcph->dest) <= fw.ipfw.fw_dpts[1] &&
			    ntohs(tcph->dest) >= fw.ipfw.fw_dpts[0]) )
				continue;
			if(!( ntohs(tcph->source) <= fw.ipfw.fw_spts[1] &&
			    ntohs(tcph->source) >= fw.ipfw.fw_spts[0]) )
				continue;
			break;
			case IPPROTO_UDP:
                        if(!( ntohs(udph->dest) <= fw.ipfw.fw_dpts[1] &&
                            ntohs(udph->dest) >= fw.ipfw.fw_dpts[0]) )
                                continue;
                        if(!( ntohs(udph->source) <= fw.ipfw.fw_spts[1] &&
                            ntohs(udph->source) >= fw.ipfw.fw_spts[0]) )
                                continue;
			break;
			}
		
		memcpy(&ret, (void *)&iph, BUFSIZ); 
		return ret;
		}

	if (b < 0)
		{
		memset(&ret, 0, sizeof(ret));
		return ret;
		}
	}

int manipulate_route(char *iface, int action, int flag)
	{
        struct rtentry rt;
        struct sockaddr_in sin;
	struct ifreq ifr;
	static int do_force;
        int fd, ret =1;

	if(!flag && do_force)
		return ret;
	else
		do_force =1;

        memset( (char *)&rt, 0, sizeof(struct rtentry));

        fd = socket(AF_INET, SOCK_DGRAM, 0);

        /* Target address. (ip of external interface) */
        strncpy(ifr.ifr_name, iface, sizeof(ifr.ifr_name));
        if (ioctl (fd, SIOCGIFHWADDR, &ifr) == -1)
                return -errno;

        memcpy(&rt.rt_dst, &ifr.ifr_hwaddr.sa_data, sizeof(struct sockaddr));

        /* Target network mask (IP).  */
        sin.sin_family = AF_INET;
        sin.sin_addr.s_addr =inet_addr("255.255.255.255");
        memcpy(&rt.rt_genmask, (struct sockaddr*)&sin, sizeof(struct sockaddr));

        rt.rt_flags = RTF_HOST;
        rt.rt_dev =iface;

	/* if action != 0 ADD, if action == 0 DEL */
        if (action) 
		{
                if (ioctl(fd, SIOCADDRT, &rt) < 0)
			ret =0;
		}
	else
		{
                if (ioctl(fd, SIOCDELRT, &rt) < 0)
			ret =0;
		}

        close(fd);
	return ret;
	}

int get_offset(int fd, char *device)
	{
	int ret;
	struct ifreq ifr;

	memset(&ifr, 0, sizeof(struct ifreq));

	strncpy(ifr.ifr_name, device, sizeof(ifr.ifr_name));
	if (ioctl (fd, SIOCGIFHWADDR, &ifr) == -1) 
		return -errno;

	switch(ifr.ifr_hwaddr.sa_family)
		{
		case ARPHRD_ETHER:
		case ARPHRD_METRICOM: 	/* linktype = DLT_EN10MB; */
		case ARPHRD_EETHER: 	/* linktype = DLT_EN3MB; */
			ret =14;
			break;
		case ARPHRD_PPP: 	/* linktype = DLT_RAW; */
			ret =0;
			break;
		case ARPHRD_LOOPBACK: 	/* linktype = DLT_NULL; */
			ret =4;
			break;
#ifdef ARPHRD_FDDI
		/* Not all versions of the kernel has this define */
		case ARPHRD_FDDI: 	/* linktype = DLT_FDDI;	*/
			ret =21;
			break;
#endif
		default:		/* linktype unkwnow or 0 */
			ret =(-1);
			break;
		}

	return ret;
	}

int work_entry(ip_chainlabel chain, struct ip_fwuser *fw, int cmd) 
	{

        int ret = 0;
        struct ip_fwnew new;

        memcpy(&new.fwn_rule, fw, sizeof(struct ip_fwuser));
        strcpy(new.fwn_label, chain);
        new.fwn_rulenum = 1;

        ret = do_setsockopt(cmd, &new, sizeof(new));

        return ret;
	}

int do_setsockopt(int cmd, void *data, int length)
	{
	int sockfd;
	sockfd = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
        return setsockopt(sockfd, IPPROTO_IP, cmd, (char *)data, length) != -1;
	}
