
#!/usr/bin/perl -w

use strict;
use FileHandle;
use IPC::Open2;
use IO::Select;
use Symbol;


$SIG{PIPE} = "IGNORE";

my($arg1,$arg2) = @ARGV;
my($r1,$w1,$r2,$w2) = (gensym,gensym,gensym,gensym);

my $pid1 = open2($r1, $w1, $arg1 );
my $pid2 = open2($r2, $w2, $arg2 );

my $old=select($w1);
$|=1;
select($w2);
$|=1;
select($old);

open(LOG,">>log.txt") || die("open: $!");
$old=select(LOG);
$|=1;
select($old);

my $s = IO::Select->new();
$s->add($r1);
$s->add($r2);


my %map = ( $r1 => $w2, $r2 => $w1 );

while(1) {
	
while(my @ready = $s->can_read) {	
	
	for my $f (@ready) {
		ready($f);
	}
}
die "select: $!" if $!;
}


sub ready {
	
	my ($pipe,$len) = shift;
	
	print "pipe: ",fileno($pipe);
	check( $pipe, $len = sysread($pipe,my $data,1024) );

	if($len) {
		print LOG $data;
		my $peer = $map{$pipe};
		check( $peer, $len = syswrite($peer,$data)  );
	}
}


sub check {
	my $p = shift;
	my $len = shift;
	if(!defined $len) {
		print "error";
		$s->remove($p);
		close($p);
	}
	elsif($len==0) {
		print "eof";
		$s->remove($p);
		close($p);
	}
}
