/************************************************************************
* SEQprobe.c            Semplice sonda per evidenziare la generazione   *
*			dell' Initial Sequence Number [ISN], necessario *
*			passo per iniziare un attacco di IP Spoofing	*
*			cieco mediante previsione del SEQ successivo.	*
*									*
*                               NO(C)1998 FuSyS TCP/IP Tools Unlimited  *
*                                                      fusys@s0ftpj.org *
************************************************************************/
/************************************************************************
* USO:                	Beh, se proprio non vi va di leggere il codice	*
*			almeno leggetevi l'articolo Progetto 0N0S3NDAi  *
*			parte II presente sul numero 6 della ezine BFi.	*
*			Butchered From inside e' prelevabile dall'URL:	*
*			http://www.s0ftpj.org/bfi/          		*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/if_ether.h>
#include <net/if.h>
#include <ioctls.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <math.h>
#include <getopt.h>

#ifndef MIN
#define MIN(x,y) (((x)<(y))?(x):(y))
#endif
#ifndef DIFF
#define DIFF(a,b) (u_long)(MIN((u_long)(a)-(u_long)(b),(u_long)(b)-(u_long)(a)))
#endif

#define MAXPROBES 		10
#define MTU                     1500
#define IP_HEADER	        20
#define TCP_HEADER           	20
#define PSEUDO_HEADER		12
#define INITSOURCE		10000
#define INITSEQ			24375400

int sp_fd, IF_LEN, iflink;
char *IF_NAME;
unsigned long localip, remoteip;
unsigned long seqs[MAXPROBES];
unsigned long seqs_diff[MAXPROBES];
unsigned long seqs_gcd;
unsigned long seqs_incr;
unsigned long seqs_sum;
unsigned short port;

struct syn_pk {
	struct iphdr ip;
	struct tcphdr tcp;
};

struct pseudo_pk {
        unsigned long saddr;
        unsigned long daddr;
        unsigned char zero;
        unsigned char proto;
        unsigned short len;
};

u_long nameResolve(char *hostname)
{
  struct in_addr addr;
  struct hostent *hostEnt;

  if((addr.s_addr=inet_addr(hostname)) == -1) {
    if(!(hostEnt=gethostbyname(hostname))) {
        printf("Name Resolution Error:`%s`\n",hostname);
        exit(0);
    }
    bcopy(hostEnt->h_addr,(char *)&addr.s_addr,hostEnt->h_length);
  }
  return addr.s_addr;
}

char *ntoa(unsigned long ip) {
        static char buff[18];
        char *p;
        p = (char *) &ip;
        sprintf(buff, "%d.%d.%d.%d",
                (p[0] & 255), (p[1] & 255), (p[2] & 255), (p[3] & 255));
        return(buff);
}

/* la solita routine di checksum */
u_short in_cksum(u_short *ptr, int nbytes)
{
  register long           sum;
  u_short                 oddbyte;
  register u_short        answer;

  sum = 0;
  while (nbytes > 1)
  {
    sum += *ptr++;
    nbytes -= 2;
  }

  if (nbytes == 1)
  {
    oddbyte = 0;           
    *((u_char *) &oddbyte) = *(u_char *)ptr;
    sum += oddbyte;
  }

  sum  = (sum >> 16) + (sum & 0xffff);   
  sum += (sum >> 16);                   
  answer = ~sum;         

  return((u_short) answer);
}

void raw(void)
{
    int opt=1;

    if((sp_fd=socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) <0){
        perror("\nRAW() Problemi inizializzazione socket raw\n");
        exit(0);
    }
    if(setsockopt(sp_fd, IPPROTO_IP, IP_HDRINCL, &opt, sizeof(opt)) <0){
            perror("RAW() Problemi inizializzazione HDRINCL\n");
            exit(0);
    }
}

int tap(char* device,int mode)
{
    int fd;
    struct ifreq ifr;

    if((fd=socket(AF_INET, SOCK_PACKET, htons(0x3))) <0){
        perror("TAP() Problemi inizializzazione SOCK_PACKET\n");
        exit(0);
    }

    strcpy(ifr.ifr_name,device);
    if (ioctl (fd, SIOCGIFADDR, &ifr) < 0) {
        perror("TAP() Impossibile ottenere l'IP locale !\n");
        exit(1);
    }
    memcpy ((void *) &localip, (void *) &ifr.ifr_addr.sa_data + 2, 4);

    if(!mode){
        close(fd);
        return(0);
    }
    else return(fd);
}

void fire_syn(unsigned short source, unsigned long seq)
{
	struct sockaddr_in sin;
        int shoot;
	struct syn_pk syn;
	struct pseudo_pk *ppk_p;
	char checkbuff[MTU];

	memset(&syn, 0, sizeof(syn));
	memset(checkbuff, 0, MTU);
	ppk_p=(struct pseudo_pk *)checkbuff;

	syn.tcp.source=source;
        syn.tcp.dest=port;
        syn.tcp.seq=seq;
	syn.tcp.doff=5;
	syn.tcp.syn=1;
	syn.tcp.window=htons(0x7000);

	ppk_p->saddr=localip;
        ppk_p->daddr=remoteip;
        ppk_p->zero=0;
        ppk_p->proto=IPPROTO_TCP;
        ppk_p->len=htons(TCP_HEADER);

	memcpy(checkbuff+PSEUDO_HEADER, &syn.tcp,
        	TCP_HEADER+PSEUDO_HEADER);
        syn.tcp.check=in_cksum((unsigned short*)checkbuff,
                        PSEUDO_HEADER+TCP_HEADER);

        syn.ip.ihl=5;
        syn.ip.version=4;
        syn.ip.tos=0;
        syn.ip.tot_len=htons(IP_HEADER+TCP_HEADER);
        syn.ip.frag_off=0;
        syn.ip.ttl=64;
        syn.ip.protocol=IPPROTO_TCP;
        syn.ip.saddr=localip;
        syn.ip.daddr=remoteip;
	syn.ip.check=in_cksum((unsigned short*)&syn.ip, IP_HEADER);

	memset(&sin, 0, sizeof(sin));
        sin.sin_family=AF_INET;
        sin.sin_port=port;
        sin.sin_addr.s_addr=remoteip;

        shoot=sendto(sp_fd, &syn, IP_HEADER+TCP_HEADER,
        	0, (struct sockaddr *)&sin, sizeof(sin));
        if(shoot<0)printf("SP_ERROR\n");
}

/* gcd functions from nmap by fyodor . sorry if not his own :) */
unsigned long euclid_gcd(unsigned long a, unsigned long b) {
  if (a < b) return euclid_gcd(b,a);
  if (!b) return a;
  return euclid_gcd(b, a % b);
}
unsigned long get_gcd_n_ulong(int numvalues, unsigned long *values) {
  int gcd;
  int i;

  if (numvalues == 0) return 1;
  gcd = values[0];
  for(i=1; i < numvalues; i++)
    gcd = euclid_gcd(gcd, values[i]);

  return gcd;
}

/* sequence checks slightly modified from fyodor */
void check_incr(void)
{
	int incr_i, i = 0;

	seqs_incr = (0.5)+ seqs_incr / MAXPROBES;
	seqs_sum = 0;
	for(i=0;i!=MAXPROBES-1;i++)
	seqs_sum += pow(DIFF(seqs_diff[i], seqs_incr),2);
	seqs_sum /= MAXPROBES;
	incr_i = (unsigned long)(0.5 + pow(seqs_sum, 0.5));
	if(incr_i < 75) 
		printf(
	"\nMicrosoft ISN Generation ! Who Do You Want To Spoof Today ?\n");
	else printf("\nRandom Incremental Box. Good Luck !\n"); 
}

void seqs_check(void)
{
	int i=0;

	seqs_incr = 0;
	for(;i!=MAXPROBES-1;i++) { 
        	printf(
	"\033[1;34mSEQ%d [\033[1;32m%u\033[1;34m]\tSEQ %d [\033[1;32m%u",
			i,ntohl(seqs[i]),i+1,ntohl(seqs[i+1]));
   		printf(
	"\033[1;34m]\tDIFF [\033[1;32m%lu\033[1;34m]\n", seqs_diff[i]);	
	} 
	seqs_gcd=get_gcd_n_ulong(MAXPROBES, seqs_diff);
	if(seqs_gcd) {
		for(i=0;i!=MAXPROBES;i++) 
			seqs_diff[i] /= seqs_gcd;
		for(i=0;i!=MAXPROBES;i++) {
			if(seqs_diff[i] > 50000000) {
				printf(
		"\nTRULY RANDOM BOX. Back Off That One :O\n");
			break;
			}
		seqs_incr += seqs_diff[i];
		}
	}
	if(seqs_gcd == 0) 
		printf(
	"\nISN CONSTANT ! Suit Yourself As You Like It :)\n");
	else if(seqs_gcd % 64000 == 0)
		printf(
	"\n64K Golden Rule ! Have a Nice Spoofing Day ...\n");
	else if(seqs_gcd % 800 == 0)
		printf(
	"\n800 Increments [64K like] !\n");
	else check_incr();
	printf("\n\033[1;34mSEQ Probing Done.\033[0m\n");
}

int main(int argc, char **argv)
{
	int opt, i=0;
	struct iphdr *ip;
	struct tcphdr *tcp;
	char packet[MTU];

	if (geteuid() || getuid()) {
                printf("Devi essere root ...\n");
                exit(0);
        }
	if (argc<7) {
            printf("\nUso: %s -h host -p porta -i interfaccia\n\n", argv[0]);
            exit(0);
        }

	while ((opt = getopt(argc, argv, "h:p:i:")) != EOF) {
                switch(opt)
                {
			case 'h':
				remoteip=nameResolve(optarg);
				break;

			case 'p':
				port=htons(atoi(optarg));
				break;

                        case 'i':
                                IF_NAME=optarg;
                                if(strstr(IF_NAME, "eth")) IF_LEN=14;
                                else if(strstr(IF_NAME, "ppp")) IF_LEN=0;
                                else {
                                        printf("solo eth|ppp.\n");
                                        exit(0);
                                }
                                break;
                        default:
                                printf("Unknown Option.\n");
                                exit(0);
                                break;
                }
        }			

	raw();
	iflink=tap(IF_NAME, 1);

	printf("\n\033[1;32mSEQ PROBE\033[0m");
        printf("\n\033[1;34mISN Generation Prober by FuSyS\033[0m");
        printf("\n\033[1;34m[S0ftPj | BFi]\033[0m\n\n");
	printf("\033[1;34mLocal  IP: \033[1;32m%s\033[0m\t", ntoa(localip));
	printf("\033[1;34mRemote IP: \033[1;32m%s\033[0m\n\n", ntoa(remoteip));

        ip = (struct iphdr *)(((char *)packet)+IF_LEN);
        tcp = (struct tcphdr *)(((char *)packet)+(sizeof(struct iphdr)+
                                        IF_LEN));
        memset(&packet, 0, sizeof(packet));
	memset(&seqs, 0, sizeof(seqs));
	memset(&seqs_diff, 0, sizeof(seqs_diff));

        for(;i!=MAXPROBES;i++) { 
                fire_syn(htons(INITSOURCE+i), htonl(INITSEQ+i));
                while(recv(iflink, &packet, sizeof(packet), 0)) {
                        if(ip->protocol == IPPROTO_TCP) {
                                if(ip->saddr == remoteip &&
                                        ip->daddr == localip) {
					if(tcp->source == port &&
					tcp->dest==htons(INITSOURCE+i) &&
					tcp->syn && tcp->ack) {
                                        	seqs[i] = tcp->seq;
						if(i>0)
						seqs_diff[i-1] = 
				DIFF(ntohl(seqs[i]), ntohl(seqs[i-1])); 
						break;
                                	}
                        	}
			}
		}
	}
	seqs_check();

	iflink=tap(IF_NAME, 0);
	exit(0);
}
